diff --git a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
index 8f833c0d6..004a75558 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-
-import static net.minecraft.client.render.OpenGLHelper.glColor1i;
 
 public class ClickableLabelElement extends ButtonElement {
     private int textColor;
@@ -43,7 +42,7 @@ public class ClickableLabelElement extends ButtonElement {
     }
 
     public int getTextColor() {
-        return textColor;
+        return this.textColor;
     }
 
     public void setTextColor(int textColor) {
@@ -51,7 +50,7 @@ public class ClickableLabelElement extends ButtonElement {
     }
 
     public int getBgColor() {
-        return bgColor;
+        return this.bgColor;
     }
 
     public void setBgColor(int bgColor) {
@@ -59,7 +58,7 @@ public class ClickableLabelElement extends ButtonElement {
     }
 
     public boolean isShadow() {
-        return shadow;
+        return this.shadow;
     }
 
     public void setShadow(boolean shadow) {
@@ -68,56 +67,57 @@ public class ClickableLabelElement extends ButtonElement {
 
     @Override
     public void drawButton(Minecraft mc, int mouseX, int mouseY) {
-        if (!visible) {
+        if (!this.visible) {
             return;
         }
+        GLRenderer.enableState(State.BLEND);
 
-        boolean hovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
-        if (hovered && enabled) {
+        boolean hovered = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
+        if (hovered && this.enabled) {
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
         }
 
         if (this.icon != null) {
-            if (hovered && enabled) {
-                this.width = 2 + this.icon.width + 4 + MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 2;
+            if (hovered && this.enabled) {
+                this.width = 2 + this.icon.width + 4 + MathHelper.ceil(mc.font.stringWidthDouble(this.displayString)) + 2;
             } else {
                 this.width = 2 + this.icon.width + 2;
             }
         } else {
-            width = MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 4;
+            this.width = MathHelper.ceil(mc.font.stringWidthDouble(this.displayString)) + 4;
         }
 
-        drawRect(xPosition, yPosition, xPosition + width, yPosition + height, enabled ? (hovered ? 0x7F8080C0 : bgColor) : 0x00000000);
+        drawRect(this.xPosition, this.yPosition, this.xPosition + this.width, this.yPosition + this.height, this.enabled ? (hovered ? 0x7F8080C0 : this.bgColor) : 0x00000000);
 
         if (this.icon != null) {
             if (hovered) {
-                if (shadow) {
-                    glColor1i(makeShadow(0xFFFFFFA0));
-                    drawGuiIcon(xPosition + 3, yPosition + 2, icon.width, icon.height, icon);
-                    glColor1i(0xFFFFFFA0);
-                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
-                    drawStringShadow(mc.font, displayString, xPosition + 4 + icon.width + 2, yPosition + 2, 0xFFFFFFA0);
+                if (this.shadow) {
+                    GLRenderer.setColor1i(makeShadow(0xFFFFFFA0));
+                    drawGuiIcon(this.xPosition + 3, this.yPosition + 2, this.icon.width, this.icon.height, this.icon);
+                    GLRenderer.setColor1i(0xFFFFFFA0);
+                    drawGuiIcon(this.xPosition + 2, this.yPosition + 1, this.icon.width, this.icon.height, this.icon);
+                    drawStringShadow(mc.font, this.displayString, this.xPosition + 4 + this.icon.width + 2, this.yPosition + 2, 0xFFFFFFA0);
                 } else {
-                    glColor1i(0xFFFFFFA0);
-                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
-                    drawStringNoShadow(mc.font, displayString, xPosition + 4 + icon.width + 2, yPosition + 2, 0xFFFFFFA0);
+                    GLRenderer.setColor1i(0xFFFFFFA0);
+                    drawGuiIcon(this.xPosition + 2, this.yPosition + 1, this.icon.width, this.icon.height, this.icon);
+                    drawStringNoShadow(mc.font, this.displayString, this.xPosition + 4 + this.icon.width + 2, this.yPosition + 2, 0xFFFFFFA0);
                 }
             } else {
-                if (shadow) {
-                    glColor1i(makeShadow(textColor));
-                    drawGuiIcon(xPosition + 3, yPosition + 2, icon.width, icon.height, icon);
-                    glColor1i(textColor);
-                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                if (this.shadow) {
+                    GLRenderer.setColor1i(makeShadow(this.textColor));
+                    drawGuiIcon(this.xPosition + 3, this.yPosition + 2, this.icon.width, this.icon.height, this.icon);
+                    GLRenderer.setColor1i(this.textColor);
+                    drawGuiIcon(this.xPosition + 2, this.yPosition + 1, this.icon.width, this.icon.height, this.icon);
                 } else {
-                    glColor1i(textColor);
-                    drawGuiIcon(xPosition + 2, yPosition + 1, icon.width, icon.height, icon);
+                    GLRenderer.setColor1i(this.textColor);
+                    drawGuiIcon(this.xPosition + 2, this.yPosition + 1, this.icon.width, this.icon.height, this.icon);
                 }
             }
         } else {
-            if (enabled && (shadow || hovered)) {
-                drawStringShadow(mc.font, displayString, xPosition + 4, yPosition + 2, hovered ? 0xFFFFFFA0 : textColor);
+            if (this.enabled && (this.shadow || hovered)) {
+                drawStringShadow(mc.font, this.displayString, this.xPosition + 4, this.yPosition + 2, hovered ? 0xFFFFFFA0 : this.textColor);
             } else {
-                drawStringNoShadow(mc.font, displayString, xPosition + 4, yPosition + 2, 0xFF7F7F7F);
+                drawStringNoShadow(mc.font, this.displayString, this.xPosition + 4, this.yPosition + 2, 0xFF7F7F7F);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java b/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
index b63e5c2bf..bcdeb7118 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
@@ -4,7 +4,6 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 public class ControllerGlyphElement extends Gui {
     public static final int GLYPH_WIDTH = 15;
@@ -69,7 +68,7 @@ public class ControllerGlyphElement extends Gui {
             this.minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
         }
 
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+//        GL11.glEnable(GL11.GL_TEXTURE_2D);
 
         drawTexturedModalRect(x, y, glyph.getU(), glyph.getV(), GLYPH_WIDTH, GLYPH_HEIGHT);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index 7131acf16..8401570ee 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -8,7 +8,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.Sys;
-import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL41;
 
 import java.text.SimpleDateFormat;
 import java.util.Date;
@@ -16,27 +16,24 @@ import java.util.Map;
 
 public class ExceptionPopupElement {
 
-    public static PopupScreen create(Screen parent, Throwable e, Minecraft mc){
-        int scale = Math.max(mc.resolution.getScale(),1);
+    public static PopupScreen create(Screen parent, Throwable e, Minecraft mc) {
+        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem!\n\n");
         s.append("To prevent more problems, the current game has quit, but you can try to keep playing.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
-                .append(TextFormatting.LIGHT_BLUE)
-                .append(" https://bugs.betterthanadventure.net/")
-                .append(TextFormatting.WHITE).append("\n\n");
-        try
-        {
+            .append(TextFormatting.LIGHT_BLUE)
+            .append(" https://bugs.betterthanadventure.net/")
+            .append(TextFormatting.WHITE).append("\n\n");
+        try {
             s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            //s1 = GL11.glGetString(7936 /*GL_VENDOR*/);
-            s.append("OpenGL: ").append(GL11.glGetString(GL11.GL_RENDERER)).append(" version ").append(GL11.glGetString(7938 /*GL_VERSION*/)).append(", ").append(GL11.glGetString(7936 /*GL_VENDOR*/)).append("\n\n");
-        }
-        catch(Throwable throwable)
-        {
+            //s1 = GL11.glGetString(GL41.GL_VENDOR);
+            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+        } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
         s.append(TextFormatting.RED).append(e);
@@ -47,35 +44,31 @@ public class ExceptionPopupElement {
         s.append(TextFormatting.WHITE);
 
 
-        PopupScreen popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
-                .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.back","gui.exception.button.copy_error"},new int[]{0,1})
-                .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
-                .build();
-        return popup;
+        return new PopupBuilder(parent, 860 / scale).withLabel("gui.exception.label.exception_occurred")
+            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+            .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.back", "gui.exception.button.copy_error"}, new int[]{0, 1})
+            .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
+            .build();
     }
 
-    public static PopupScreen createFatal(Throwable e, Minecraft mc){
-        int scale = Math.max(mc.resolution.getScale(),1);
+    public static PopupScreen createFatal(Throwable e, Minecraft mc) {
+        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem that it cannot recover from!\n\n");
         s.append("The current game has quit, please restart the game.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
-                .append(TextFormatting.LIGHT_BLUE)
-                .append(" https://bugs.betterthanadventure.net/")
-                .append(TextFormatting.WHITE).append("\n\n");
-        try
-        {
+            .append(TextFormatting.LIGHT_BLUE)
+            .append(" https://bugs.betterthanadventure.net/")
+            .append(TextFormatting.WHITE).append("\n\n");
+        try {
             s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            //s1 = GL11.glGetString(7936 /*GL_VENDOR*/);
-            s.append("OpenGL: ").append(GL11.glGetString(7937 /*GL_RENDERER*/)).append(" version ").append(GL11.glGetString(7938 /*GL_VERSION*/)).append(", ").append(GL11.glGetString(7936 /*GL_VENDOR*/)).append("\n\n");
-        }
-        catch(Throwable throwable)
-        {
+            //s1 = GL11.glGetString(GL41.GL_VENDOR);
+            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+        } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
         s.append(TextFormatting.RED).append(e);
@@ -87,36 +80,32 @@ public class ExceptionPopupElement {
 
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
-        PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.fatal_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
-                .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
-                .withBackgroundColor(0xff402020, 0xff501010)
-                .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
-                .build();
-        return popup;
+        return new PopupBuilder(screen, 860 / scale).withLabel("gui.exception.label.fatal_error")
+            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+            .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.copy_error", "gui.exception.button.copy_error_and_quit"}, new int[]{0, 2}, new boolean[]{false, true})
+            .withBackgroundColor(0xff402020, 0xff501010)
+            .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
+            .build();
     }
 
-    public static PopupScreen createStartupError(Throwable e, Minecraft mc){
-        int scale = Math.max(mc.resolution.getScale(),1);
+    public static PopupScreen createStartupError(Throwable e, Minecraft mc) {
+        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("An error has prevented Minecraft from starting up correctly!\n\n");
         s.append("The game cannot continue, please restart the game.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
-                .append(TextFormatting.LIGHT_BLUE)
-                .append(" https://bugs.betterthanadventure.net/")
-                .append(TextFormatting.WHITE).append("\n\n");
-        try
-        {
+            .append(TextFormatting.LIGHT_BLUE)
+            .append(" https://bugs.betterthanadventure.net/")
+            .append(TextFormatting.WHITE).append("\n\n");
+        try {
             s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            //s1 = GL11.glGetString(7936 /*GL_VENDOR*/);
-            s.append("OpenGL: ").append(GL11.glGetString(GL11.GL_RENDERER)).append(" version ").append(GL11.glGetString(7938 /*GL_VERSION*/)).append(", ").append(GL11.glGetString(7936 /*GL_VENDOR*/)).append("\n\n");
-        }
-        catch(Throwable throwable)
-        {
+            //s1 = GL41.glGetString(GL41.GL_VENDOR);
+            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+        } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
         s.append(TextFormatting.RED).append(e);
@@ -128,13 +117,12 @@ public class ExceptionPopupElement {
 
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
-        PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.startup_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
-                .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
-                .withBackgroundColor(0xff402020, 0xff501010)
-                .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
-                .build();
-        return popup;
+        return new PopupBuilder(screen, 860 / scale).withLabel("gui.exception.label.startup_error")
+            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+            .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.copy_error", "gui.exception.button.copy_error_and_quit"}, new int[]{0, 2}, new boolean[]{false, true})
+            .withBackgroundColor(0xff402020, 0xff501010)
+            .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
+            .build();
     }
 
     private static class PopupListener implements PopupCloseListener {
@@ -142,25 +130,23 @@ public class ExceptionPopupElement {
         private final Minecraft mc;
         private final String message;
 
-        private PopupListener(Minecraft mc, String message){
+        private PopupListener(Minecraft mc, String message) {
             this.mc = mc;
             this.message = message;
         }
 
         @Override
         public void onClosed(int statusCode, @NotNull Map<String, ?> results) {
-            switch (statusCode){
-                case 0:
-                    mc.hasCrashed = false;
-                    break;
-                case 1:
-                    Global.accessor.copyToClipboard(message);
-                    mc.hasCrashed = false;
-                    break;
-                case 2:
-                    Global.accessor.copyToClipboard(message);
-                    mc.shutdownMinecraftApplet();
-                    break;
+            switch (statusCode) {
+                case 0 -> this.mc.hasCrashed = false;
+                case 1 -> {
+                    Global.accessor.copyToClipboard(this.message);
+                    this.mc.hasCrashed = false;
+                }
+                case 2 -> {
+                    Global.accessor.copyToClipboard(this.message);
+                    this.mc.shutdownMinecraftApplet();
+                }
             }
         }
     }
